"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDefaultAlbumName = void 0;
const path_1 = require("path");
const specialFormats = [
    {
        name: 'TlmcWithDiscId',
        regex: /\[.+?\]$/,
        resolve: match => match[1],
    },
    {
        name: 'Tlmc',
        regex: /^[\d]{4}\.[\d]{2}\.[\d]{2} (.+?) \[.+?\]$/,
        resolve: match => match[1],
    },
    {
        name: 'Default',
        regex: /.+/,
        resolve: match => match[0],
    },
];
const getDefaultAlbumName = (currentFolder = (0, path_1.basename)(process.cwd())) => {
    const [formatMatch] = specialFormats
        .map(f => {
        const match = currentFolder.match(f.regex);
        if (match) {
            return f.resolve(match);
        }
        return null;
    })
        .filter((it) => it !== null);
    return formatMatch || currentFolder;
};
exports.getDefaultAlbumName = getDefaultAlbumName;
