"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.localJson = exports.LocalJson = void 0;
const fs_1 = require("fs");
const metadata_source_1 = require("../metadata-source");
const exists_1 = require("../../exists");
const normalize_1 = require("../normalize/normalize");
class LocalJson extends metadata_source_1.MetadataSource {
    async normalize(metadatas, cover) {
        return (0, normalize_1.expandMetadataInfo)({ metadatas, cover });
    }
    async normalizeWithoutCover(metadatas) {
        return (0, normalize_1.expandMetadataInfoWithoutCover)({ metadatas });
    }
    async resolveAlbumName(localSource) {
        return (0, exists_1.resolvePath)(localSource);
    }
    async getMetadata(fullPath, cover) {
        const jsonMetadata = JSON.parse((0, fs_1.readFileSync)(fullPath, { encoding: 'utf8' }));
        const metadata = await this.normalize(jsonMetadata, cover);
        return metadata;
    }
}
exports.LocalJson = LocalJson;
exports.localJson = new LocalJson();
