"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.altNamesPlugin = void 0;
const alt_names_1 = require("../alt-names");
/** 使用 alt-names 的数据进行替换 */
const altNamesPlugin = () => {
    const altNameFields = ['artists', 'lyricists', 'composers'];
    return ({ metadata }) => {
        altNameFields.forEach(field => {
            if (!altNameFields.includes(field) || !Array.isArray(metadata[field])) {
                return;
            }
            const values = metadata[field];
            const replaceValues = values.map(v => {
                const replaceValue = alt_names_1.altNames.get(v);
                if (replaceValue !== undefined) {
                    return replaceValue;
                }
                return v;
            });
            metadata[field] = replaceValues;
        });
    };
};
exports.altNamesPlugin = altNamesPlugin;
