"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.simplifyArtistsPlugin = exports.expandArtistsPlugin = void 0;
/** 省略 artists 且带有 composers 时, 使用 composers 填充 artists */
const expandArtistsPlugin = () => {
    return ({ metadata }) => {
        if (!metadata.artists && metadata.composers) {
            metadata.artists = metadata.composers;
        }
    };
};
exports.expandArtistsPlugin = expandArtistsPlugin;
/** artists 和 composers 相同时, 省略 artists */
const simplifyArtistsPlugin = () => {
    return ({ metadata }) => {
        if (Array.isArray(metadata.artists) &&
            Array.isArray(metadata.composers) &&
            metadata.artists.every((item, index) => item === metadata.composers[index])) {
            delete metadata.artists;
        }
    };
};
exports.simplifyArtistsPlugin = simplifyArtistsPlugin;
