/// <reference types="node" />
import type { Metadata } from '../metadata';
export type MetadataNormalizePlugin = (init: {
    cover?: Buffer;
}) => (context: {
    metadata: Metadata;
    index: number;
}) => void | Promise<void>;
/** 为简化的 Metadata JSON 填充完整信息 */
export declare const expandMetadataInfo: (params: {
    metadatas: Metadata[];
    cover?: Buffer;
}) => Promise<Metadata[]>;
/** 为简化的 Metadata JSON 填充完整信息, 但不处理封面图 */
export declare const expandMetadataInfoWithoutCover: (params: {
    metadatas: Metadata[];
}) => Promise<Metadata[]>;
/** 对 Metadata JSON 进行简化 */
export declare const simplifyMetadataInfo: (params: {
    metadatas: Metadata[];
    cover?: Buffer;
}) => Promise<Metadata[]>;
/** 对 Metadata JSON 进行简化, 允许合并相同的 artists 和 composers (用于原创曲) */
export declare const simplifyMetadataInfoWithArtists: (params: {
    metadatas: Metadata[];
    cover?: Buffer;
}) => Promise<Metadata[]>;
