/// <reference types="node" />
import { MetadataSource } from '../metadata-source';
import { Metadata } from '../metadata';
export declare class ThbWiki extends MetadataSource {
    readonly host: string;
    constructor(host?: string);
    cache: Map<string, {
        document: Document;
        cover: Buffer | undefined;
    }>;
    resolveAlbumName(albumName: string): Promise<string | string[]>;
    private getAlbumCover;
    private getAlbumData;
    private getRelatedRows;
    private parseRelatedRowInfo;
    private rowDataNormalize;
    private parseRow;
    getMetadata(albumName: string, cover?: Buffer): Promise<Metadata[]>;
}
export declare const thbWiki: ThbWiki;
export declare const thbWikiCache: ThbWiki;
