"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mp3Reader = exports.Mp3Reader = void 0;
const metadata_reader_1 = require("../metadata-reader");
const languageCodeConvert = (code) => {
    const mapping = {
        jpn: 'ja',
        deu: 'de',
        zho: 'zh',
    };
    return code ? mapping[code] || mapping.jpn : mapping.jpn;
};
class Mp3Reader extends metadata_reader_1.MetadataReader {
    async readRaw(input) {
        const { readFileSync } = await Promise.resolve().then(() => __importStar(require('fs')));
        const id3 = await Promise.resolve().then(() => __importStar(require('node-id3')));
        const tag = id3.read(typeof input === 'string' ? readFileSync(input) : input);
        return tag;
    }
    async read(input) {
        const tag = typeof input === 'string' || input instanceof Buffer ? await this.readRaw(input) : input;
        const { separator } = this.config;
        const metadata = {
            title: tag.title ?? '',
            artists: tag.artist?.split(separator) ?? [],
            album: tag.album ?? '',
            albumOrder: tag.albumOrder ?? '',
            discNumber: tag.partOfSet ?? '',
            trackNumber: tag.trackNumber ?? '',
            composers: tag.composer?.split(separator),
            genres: tag.genre?.split(separator),
            year: tag.year,
            lyricists: tag.textWriter?.split(separator),
            albumArtists: tag.performerInfo?.split(separator),
            comments: tag.comment?.text,
            lyric: tag.unsynchronisedLyrics?.text,
            lyricLanguage: tag.unsynchronisedLyrics
                ? languageCodeConvert(tag.unsynchronisedLyrics?.language)
                : undefined,
            coverImage: tag.image?.imageBuffer,
        };
        return metadata;
    }
}
exports.Mp3Reader = Mp3Reader;
exports.mp3Reader = new Mp3Reader();
