"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.flacWriter = exports.FlacWriter = void 0;
const flac_tagger_1 = require("flac-tagger");
const metadata_writer_1 = require("../metadata-writer");
const getVorbisComments = (metadata) => {
    const tagMap = {
        artist: metadata.artists,
        title: metadata.title,
        album: metadata.album,
        albumSort: metadata.albumOrder,
        trackNumber: metadata.trackNumber,
        discNumber: metadata.discNumber,
    };
    if (metadata.composers) {
        tagMap.composer = metadata.composers;
    }
    if (metadata.comments) {
        tagMap.comment = metadata.comments;
    }
    if (metadata.lyric) {
        tagMap.lyric = metadata.lyric;
    }
    if (metadata.lyricists) {
        tagMap.lyricist = metadata.lyricists;
    }
    if (metadata.albumArtists) {
        tagMap.albumArtist = metadata.albumArtists;
    }
    if (metadata.genres) {
        tagMap.genre = metadata.genres;
    }
    if (metadata.year) {
        tagMap.date = metadata.year;
    }
    return tagMap;
};
class FlacWriter extends metadata_writer_1.MetadataWriter {
    async write(metadata, filePath) {
        const coverBuffer = await (async () => {
            if (!metadata.coverImage) {
                return undefined;
            }
            const { compressImageByConfig } = await Promise.resolve().then(() => __importStar(require('../image-compress')));
            return compressImageByConfig(metadata.coverImage, this.config);
        })();
        await (0, flac_tagger_1.writeFlacTags)({
            tagMap: getVorbisComments(metadata),
            picture: coverBuffer
                ? {
                    description: metadata.album,
                    buffer: coverBuffer,
                }
                : undefined,
        }, filePath);
    }
}
exports.FlacWriter = FlacWriter;
exports.flacWriter = new FlacWriter();
